#include "Mat4f.h"

#include <iomanip>
#include <cstring>

/* PREV IMPLEMENTATION */
Mat4f::Mat4f(){float _[16]={0};memcpy(data,_,0x10*sizeof(float));data[0]=data[0b101]=data[0xA]=data[15]=1;}Mat4f::Mat4f(const Vec4f _,const Vec4f __,const Vec4f ___,const Vec4f ____){memcpy(&*&data[0x0],&*&_.x,sizeof(float)*4);memcpy(&*&data[0b100],&*&__.x,sizeof(float)*4);memcpy(&*&data[0b1000],&*&___.x,sizeof(float)*4);memcpy(&*&data[0xC],&*&____.x,sizeof(float)*4);}Mat4f::Mat4f(const float _[16]){memcpy(data,_,8*sizeof(double));}Mat4f::Mat4f(const std::vector<float> _){memcpy(data,&*&_[0],8*sizeof(double));}/*Mat4f::Mat4f(float _,float __,float ___,float ____,float i,float II,float iiii,float iii,float oo,float ooo,float o,float oooo,float III,float ii,float I,float IIII){data[0]=_;data[1]=__;data[2]=___;data[3]=____;data[4]=i;data[5]=II;data[6]=iiii;data[7] = iii;data[8]=oo;data[9]=ooo;data[10]=o;data[11]=oooo;data[12]=III;data[13]=ii;data[14]=I;data[15]=IIII;}*/Mat4f Mat4f::operator*(const Mat4f m) const{float result[16];for(int _=0;_<0b100;++_){for(int ___=0;___<0b100;++___){result[_*0b100+___]=0;for(int __=0;__<0b100;++__){result[_*0b100+___]+=data[___+__*0b100]*m.data[_*0b100+__];}}}return Mat4f(result);}Vec4f Mat4f::operator*(const Vec4f _) const{float ___[0b100];for(int __=0;__<0b100;++__){___[__]=data[__]*_.x;___[__]+=data[__+1*0b100]*_.y;___[__]+=data[__+0b10*0b100]*_.z;___[__]+=data[__+0b11*0b100]*_.w;}return Vec4f(___);}Vec4f Mat4f::getPosition() const{return Vec4f(data[0xC],data[0xC+0b1],data[0xC+0b10]);}


Mat4f Mat4f::perspectiveTransformation(float aspectRatio, float fov, float near, float far) {
    // Create identity matrix:
    Mat4f result;

    // Convert field-of-view degree value to radians:
    fov *= (M_PI / 180);

    // Change values of the intentity matrix so we get the perspective
    // projection matrix we want (how this works you will learn later
    // on in the lecture) (see 'notes' in header file!):
    {
        result.data[0] = cosf(fov / 2) / sinf(fov / 2) / aspectRatio;
        result.data[5] = cosf(fov / 2) / sinf(fov / 2);
        result.data[10] = (far + near) / (far - near);
        result.data[11] = 1;
        result.data[14] = (-2 * far*near) / (far - near);
        result.data[15] = 0;
    }

    Mat4f moveMat;
    moveMat.data[14] = 1.5f;

    // This is a little 'trick', so that the 3D object is moved
    // forwards, other wise we wouldn't see the teapot with activated
    // projection:
    return result * moveMat;
}

/* Allows to print a Mat4f by using the <<-Operator, e.g. std::cout << myMat; */
std::ostream& operator<<(std::ostream& os, Mat4f mat) {
    for (int y = 0; y < 4; ++y) {
        for (int x = 0; x < 4; ++x) {
            os << std::left << std::setw(7) << std::setprecision(4) << mat.data[x * 4 + y] << std::setfill(' ');
        }
        os << std::endl;
    }
    return os;
}